var localPreview = String(window.location).indexOf('http') == -1;

function initializeLocalPreview() {
//	console.log('initializeLocalPreview')

	var ua = navigator.userAgent;
	EB = {
		_adConfig: {
			adId: 0,
			rnd: 0,
			uid: 0,
			customJSVars: {
				//This will be a different list for each ad format, these are just example vars.
				//You only need to add the vars that the workspace script(s) may use, not vars that
				//are needed only in the custom script.
			}
		},
		_sendMessage: function (event, params) {
			handleMessageForPlatform(event, params)
		},
		API: {
			browser: {
				webkit: ua.match(/webkit/i) !== null,
				firefox: ua.match(/firefox/i) !== null
			},
			os: {
				ua: ua,
				ios: ua.match(/ipod|iphone|ipad/i) !== null,
				android: ua.match(/android/i) !== null,
				windowphone: ua.match(/windows phone/i) !== null,
				mobile: ua.match(/ipod|iphone|ipad|android|windows phone/i) !== null
			},
			setStyle: function (obj, styles) {
				for(var style in styles) {
					if(!styles.hasOwnProperty(style)) continue;
					obj.style[style] = styles[style];
				}
			},
			setClass: function (elem, class_name, override) {
				var current_class_name = "";
				if(elem.hasAttribute("class")) {
					current_class_name = elem.getAttribute("class");
					if(current_class_name !== "") {
						var class_names = current_class_name.split(" ");
						for(var i = 0; i < class_names.length; i++) {
							if(class_names[i] === class_name) {
								return;
							}
						}
					}
				}
				if(class_name !== "") {
					current_class_name = current_class_name === "" ? class_name : current_class_name + " " + class_name;
				}
				elem.setAttribute("class", override ? class_name : current_class_name);
			},
			removeClass: function (elem, class_name) {
				var current_class_name = "";
				var new_class_name = "";
				if(elem.hasAttribute("class")) {
					current_class_name = elem.getAttribute("class");
					if(current_class_name !== "") {
						var class_names = current_class_name.split(" ");
						for(var i = 0; i < class_names.length; i++) {
							if(class_names[i] !== class_name) {
								new_class_name += class_names[i] + " ";
							}
						}
					}
				}
				elem.setAttribute("class", new_class_name.replace(/\s$/i, ""));
			},
			getCustomVar: function (name) {
				return EB._adConfig.customJSVars[name];
			},
			getViewPortMetrics: function () {
				return {
					Height: window.innerHeight,
					height: window.innerHeight,
					Width: window.innerWidth,
					width: window.innerWidth
				};
			}
		},
		Comm: {
			setName: function (name) {
				return name;
			},
			isConnected: function (name) {
				return true;
			}
		},
		getSDKData: function () {
			return null;
		},
		expand: function (obj) {
			top.location.replace("panels/" + obj.panelName + "/index.html", "self");
			return false;
		},
		collapse: function (obj) {
			top.location.replace("../../index.html");
			return false;
		},
		setExpandProperties: function () {
			return true;
		},
		clickthrough: function () {
			return true;
		},
		automaticEventCounter: function () {
			return true;
		},
		userActionCounter: function () {
			return true;
		}
	};
	EBG = {
		ActionType: {
			USER: "user",
			AUTO: "auto"
		},
		px: function (n) {
			if(Math.abs(n).toString().match(/^\d$|^\d+$/) !== null) {
				return n + "px";
			}
			return n;
		},
		pm: {
			bind: function() {
				return true;
			}
		},
		VideoModule: function (video) {
			return {
				_videoElement: video,
				playVideo: function () {
					this._videoElement.play();
				}
			};
		},
		API: {
			Adaptor: {
				setStyle: function(elem, oStyles) {
					console.log('setStyle', elem, oStyles)
					for (var style in oStyles) {
						if (elem.hasOwnProperty(style))
							elem[style] = oStyles[style];
						else  if (elem.hasOwnProperty('style'))
							elem.style[style] = oStyles[style];
					}
				}
			}
		}
	};
	addEventListener("message", handleMessageFromPlatform);
	function handleMessageFromPlatform (event) {
	//	console.log("localPreview recieved message", event.data)
		var data = JSON.parse(event.data);
		if(data.type === "ebCallbackFunction") {	//setPRConfiguration
			var func = eval(data.data.functionName);
			if(typeof func === "function") {
				func(data.data.parameters);
			}
		}
	}
	function handleMessageForPlatform (event, params) {
	//	console.log("localPreview recieved message", event, ParallaxRevealLocal[event], params)
		if (ParallaxRevealLocal[event]) ParallaxRevealLocal[event](params);
	}
	function onPageScroll(e) {
		ParallaxRevealLocal.callbackListener(e);
	}
	
	var ParallaxRevealLocal = {
		callbackArray: [],
		setPRCallback: function (messageData) {
			this.callbackArray.push(messageData);
		},
		callbackListener: function (e) {
			var height = window.innerHeight;

			for (var i = 0; i < this.callbackArray.length; i++) {
				var y1 = this.callbackArray[i].y1;
				var y2 = this.callbackArray[i].y2;
			
				if (y1.toString().match(/%/) !== null) {
					y1 = height * parseFloat(y1) / 100;
				}

				if (y2.toString().match(/%/) !== null) {
					y2 = height * parseFloat(y2) / 100;
				}

				if (e.scrollVertical * height >= y1 && e.scrollVertical * height <= y2) {
				//	console.log(y1, '<', e.scrollVertical*height, '<', y2, this.callbackArray[i].name)
					var msg = {
						type: "ebCallbackFunction",
						data: {
							functionName: this.callbackArray[i].name,
							parameters: {
								y1: y1,
								y2: y2,
								scrollVertical: e.scrollVertical
							}
						}
					};
					postMessage(JSON.stringify(msg), "*");
				}
			}
		}	
	}
	
	var visibilityStyle = document.createElement("style");
	visibilityStyle.innerHTML = "html, body, div, video {visibility: visible !important;}";
	document.getElementsByTagName("head")[0].appendChild(visibilityStyle);
	
	// set parallax reveal configuration
	setPRConfiguration({
		minContainerWidth: 320,
		maxContainerWidth: '100%',
		minContainerHeight: '20%',
		maxContainerHeight: '400px',
		fixedContainerWidth: 200,
		fixedContainerHeight: -1,
		aspectRatio: '4:3',
		heightDependency: 'adaptive',	//'fixed', 'advertiserDiv', 'aspectRatio', 'adaptive', 'default'
		useOrientation: true,
		adaptiveBreakpoints: '0:250,900:400',
		backgroundImagePath: 'images/background1.jpg, images/background2.jpg',
		sizes: [ { width: 1,   height: 250, background: "images/background1.jpg" }, 
				 { width: 900, height: 400, background: "images/background2.jpg" } ]
	});
}